function [ ] = generate_plots(t_end, h, trans, pos_n,vel_n, pos_est,vel_est, bias_est)
%UNTITLED4 Summary of this function goes here
%   Detailed explanation goes here


figure()
plot(pos_n(2,1:end-1), pos_n(1,1:end-1), 'b');
hold on
plot(pos_est(2,1:end-1), pos_est(1,1:end-1), 'r'); 
legend('True position in NED', 'Estimated position in NED');
xlabel('East [m]');
ylabel('North [m]');
title('ROV trace');

figure()
plot3(pos_n(1,:), pos_n(2,:), pos_n(3,:)); 
axis([-20 80 -20 60 -20 40]); 
xlabel('North [m]');
ylabel('East [m]');
zlabel('Up [m]');
title('Plot of trajectory')
% 
figure()
subplot(311), plot(h:h:t_end, vel_n(1,:), 'b', h:h:t_end-h, vel_est(1,1:end-1),'g'), xlabel('Time [s]'), ylabel('North velocity [m/s]'), legend('True', 'EKF', 'location','northeast'), title('North velocity');
subplot(312), plot(h:h:t_end, vel_n(2,:), 'b', h:h:t_end-h, vel_est(2,1:end-1),'g'), xlabel('Time [s]'), ylabel('East velocity [m/s]'), legend('True', 'EKF', 'location','northeast'), title('East velocity');
subplot(313), plot(h:h:t_end, vel_n(3,:), 'b', h:h:t_end-h, vel_est(3,1:end-1),'g'), xlabel('Time [s]'), ylabel('Down velocity [m/s]'), legend('True', 'EKF', 'location','northeast'), title('Down velocity');
% 
% figure()
% plot3(pos_n(1,:), pos_n(2,:), pos_n(3,:),'b', pos_gen(1,1:end-1), pos_gen(2,1:end-1), pos_gen(3,1:end-1), '*r'); 
% axis([-20 80 -20 60 -20 40]); 
% legend('True trajectory', 'Algebraic transformation');
% xlabel('North [m]');
% ylabel('East [m]');
% zlabel('Up [m]');

% figure()
% plot(h:h:t_end-h, pos_n(3,1:end-1), 'b', h:h:t_end-h, pos_gen(3,1:end-1), '*r'); 
% %axis([-20 80 -20 60 -20 40]); 
% legend('True trajectory', 'Algebraic transformation');
% xlabel('North [m]');
% ylabel('East [m]');

figure()
plot(h:h:t_end-h, pos_n(3,1:end-1), 'b'); 
%axis([-20 80 -20 60 -20 40]); 
legend('True trajectory');
xlabel('North [m]');
ylabel('East [m]');

% figure()
% plot(pos_n(2,:), pos_n(1,:), 'b', pos_gen(2,1:end-1), pos_gen(1,1:end-1), '*r'); 
% axis([-5 35 0 70]); 
% legend('True trajectory', 'Algebraic transformation');
% xlabel('North [m]');
% ylabel('East [m]');


figure()
subplot(311), plot(h:h:t_end, pos_n(1,:), 'b', h:h:t_end-h, pos_est(1,1:end-1), 'g'), title('Position in North'), xlabel('Time [s]'), ylabel('North [m]'), legend('True', 'EKF', 'location', 'northwest');
subplot(312), plot(h:h:t_end, pos_n(2,:), 'b', h:h:t_end-h, pos_est(2,1:end-1), 'g'), title('Position in East'), xlabel('Time [s]'), ylabel('East [m]'), legend('True', 'EKF', 'location', 'northwest');
subplot(313), plot(h:h:t_end, pos_n(3,:), 'b', h:h:t_end-h, pos_est(3,1:end-1), 'g'), title('Position in Down'), xlabel('Time [s]'), ylabel('Down [m]'),legend('True', 'EKF', 'location', 'northwest');

bias = bias_est(1,1:end-1)*1450; 
n = length(bias_est(1,1:end-1)); 
bias_true = 1450*ones(1,n); 
rms = sqrt((bias_est(1,1:end-1)-1).^2/n); 
figure()
subplot(211), plot(h:h:t_end-h, bias_true,h:h:t_end-h,bias), title('Bias'), xlabel('Time [s]'), ylabel('Beta []'), legend('True', 'EKF'); 
subplot(212), plot(h:h:t_end-h, rms), title('RMSE for Beta'), xlabel('Time [s]'), ylabel('RMSE'); 

% errorx = pos_n(1,1:end) - pos_est(1,1:end);
% errory = pos_n(2,1:end) - pos_est(2,1:end); 
% errorz = pos_n(3,1:end) - pos_est(3,1:end); 

errorx = pos_n(1,1:end-1) - pos_est(1,1:end-1);
errory = pos_n(2,1:end-1) - pos_est(2,1:end-1); 
errorz = pos_n(3,1:end-1) - pos_est(3,1:end-1); 

% errorvx = veln(1,1:end) - vel_est(1,1:end);
% errorvy = veln(2,1:end) - vel_est(2,1:end);
% errorvz = veln(3,1:end) - vel_est(3,1:end);

errorvx = vel_n(1,1:end-1) - vel_est(1,1:end-1);
errorvy = vel_n(2,1:end-1) - vel_est(2,1:end-1);
errorvz = vel_n(3,1:end-1) - vel_est(3,1:end-1); 

% figure()
% subplot(311), plot(h:h:t_end, errorx, 'Linewidth', 1), title('North position error'), xlabel('Time [s]'), ylabel('North position error'); 
% subplot(312), plot(h:h:t_end, errory, 'Linewidth', 1), title('East position error'), xlabel('Time [s]'), ylabel('East position error'); 
% subplot(313), plot(h:h:t_end, errorz, 'Linewidth', 1), title('Down position error'), xlabel('Time [s]'), ylabel('Down position error'); 
% 
% figure()
% subplot(311), plot(h:h:t_end, errorvx, 'Linewidth', 1), title('North Velocity error'), xlabel('Time [s]'), ylabel('North Velocity error'); 
% subplot(312), plot(h:h:t_end, errorvy, 'Linewidth', 1), title('East Velocity error'), xlabel('Time [s]'), ylabel('East Velocity error'); 
% subplot(313), plot(h:h:t_end, errorvz, 'Linewidth', 1), title('Down Velocity error'), xlabel('Time [s]'), ylabel('Down Velocity error'); 

figure()
subplot(311), plot(h:h:t_end-h, errorx, 'Linewidth', 1), title('North position error'), xlabel('Time [s]'), ylabel('North position error [m]'); 
subplot(312), plot(h:h:t_end-h, errory, 'Linewidth', 1), title('East position error'), xlabel('Time [s]'), ylabel('East position error [m]'); 
subplot(313), plot(h:h:t_end-h, errorz, 'Linewidth', 1), title('Down position error'), xlabel('Time [s]'), ylabel('Down position error [m]'); 

figure()
subplot(311), plot(h:h:t_end-h, errorvx, 'Linewidth', 1), title('North Velocity error'), xlabel('Time [s]'), ylabel('North Velocity error [m/s]'); 
subplot(312), plot(h:h:t_end-h, errorvy, 'Linewidth', 1), title('East Velocity error'), xlabel('Time [s]'), ylabel('East Velocity error [m/s]'); 
subplot(313), plot(h:h:t_end-h, errorvz, 'Linewidth', 1), title('Down Velocity error'), xlabel('Time [s]'), ylabel('Down Velocity error [m/s]'); 


figure()
plot3(pos_n(1,1:end-1) , pos_n(2,1:end-1), pos_n(3,1:end-1), 'b', pos_est(1,1:end-1), pos_est(2,1:end-1), pos_est(3,1:end-1), 'g'); 
%axis([-20 80 -10 40 -10 40]); 
axis([-20 80 -10 50 -10 40]); 
hold on;
plot3(trans.p1(1), trans.p1(2), trans.p1(3), 'ko'); 
plot3(trans.p2(1), trans.p2(2), trans.p2(3), 'ko'); 
plot3(trans.p3(1), trans.p3(2), trans.p3(3), 'ko'); 
plot3(trans.p4(1), trans.p4(2), trans.p4(3), 'ko'); 
legend('True trajectory', 'EKF', 'Transponders'); 
xlabel('North [m]');
ylabel('East [m]');
zlabel('Up [m]');

end


