% TRAJECTORY 

filetype = '-depsc2';
folder   = 'figures/';
filename ='v_trans_traj';

%-Plotting
fg5 = figure(1);
hold on
clf;

hold on;
load('transient.mat')

plot(pos_est(2,:), pos_est(1,:), 'g', pos_est2(2,:), pos_est2(1,:),'b', qualisys(3,:), qualisys(2,:), '-r');
xlabel('North [m]', 'fontsize', 14), ylabel('East [m]', 'fontsize', 14); 
L = legend('TSF','EKF','Qualisys','Location','SouthWest');

set(L, 'fontsize', 14); 

fg5.PaperPositionMode = 'auto';
print(fg5,filetype,strcat(folder,filename));

% POSITION ERROR 

filetype = '-depsc2';
folder   = 'figures/';
filename ='v_trans_pos_error';

%-Plotting
fg2 = figure(2);
hold on
clf;


subplot(311), plot(qualisys(1,:), errorx, '-g', qualisys(1,:), errorx2, 'b'), ylabel('North [m]','fontsize', 14), xlabel('Time [s]', 'fontsize', 14);
a = legend('TSF','EKF','Location','NorthEast'); 
subplot(312), plot(qualisys(1,:), errory, '-g', qualisys(1,:), errory2, 'b'), ylabel('East [m]', 'fontsize', 14), xlabel('Time [s]', 'fontsize', 14);
b = legend('TSF','EKF', 'Location','SouthEast');
subplot(313), plot(qualisys(1,:), errorz, '-g', qualisys(1,:), errorz2, 'b'), ylabel('Down [m]', 'fontsize', 14), xlabel('Time [s]','fontsize', 14);
c = legend('TSF','EKF', 'Location','NorthEast');

set(a,'FontSize',14)
set(b,'FontSize',14)
set(c,'FontSize',14)

fg2.PaperPositionMode = 'auto';
print(fg2,filetype,strcat(folder,filename));

filetype = '-depsc2';
folder   = 'figures/';
filename ='v_trans_vel';

%-Plotting
fg3 = figure(3);
hold on
clf;

subplot(311), plot(qualisys(1,:), errorvx, '-g', qualisys(1,:), errorvx2, 'b'), ylabel('North [m/s]','fontsize', 14), xlabel('Time [s]', 'fontsize', 14);
a = legend('TSF','EKF','Location','NorthEast'); 
subplot(312), plot(qualisys(1,:), errorvy, '-g', qualisys(1,:), errorvy2, 'b'), ylabel('East [m/s]', 'fontsize', 14), xlabel('Time [s]', 'fontsize', 14);
b = legend('TSF','EKF', 'Location','SouthEast');
subplot(313), plot(qualisys(1,:), errorvz, '-g', qualisys(1,:), errorvz2, 'b'), ylabel('Down [m/s]', 'fontsize', 14), xlabel('Time [s]','fontsize', 14);
c = legend('TSF','EKF', 'Location','NorthEast');

set(a,'FontSize',14)
set(b,'FontSize',14)
set(c,'FontSize',14)

fg3.PaperPositionMode = 'auto';
print(fg3,filetype,strcat(folder,filename));

filetype = '-depsc2';
folder   = 'figures/';
filename ='v_trans_bias_wave';

%-Plotting
fg4 = figure(4);
hold on
clf;

plot(qualisys(1,:), bias_est, qualisys(1,:), bias_est2), xlabel('Time [s]', 'fontsize', 14), ylabel('Beta [-]', 'fontsize', 14); 
plot(qualisys(1,:), true, qualisys(1,:), sqrt(bias_est)*1450, qualisys(1,:), sqrt(bias_est2)*1450), xlabel('Time [s]', 'fontsize', 14), ylabel('Beta [-]', 'fontsize', 14), 
a = legend('True','TSF', 'EKF'); 
set(a,'FontSize',14)

fg4.PaperPositionMode = 'auto';
print(fg4,filetype,strcat(folder,filename));


filetype = '-depsc2';
folder   = 'figures/';
filename ='v_trans_bias2';

%-Plot 1 settings
xLabel_FSize = 14;
yLabel_FSize = 14;
legend_FSize = 14;

%-Plotting
fg5 = figure(5);
hold on
clf;

subplot(311), plot(qualisys(1,:), bias2_est(1,:), '-g', qualisys(1,:), bias2_est2(1,:), 'b'), ylabel('Bias in a_x^b [m/s^2]','fontsize', 14), xlabel('Time [s]', 'fontsize', 14);
a = legend('TSF','EKF','Location','NorthEast'); 
subplot(312), plot(qualisys(1,:), bias2_est(2,:), '-g', qualisys(1,:), bias2_est2(2,:), 'b'), ylabel('Bias in a_y^b [m/s^2]', 'fontsize', 14), xlabel('Time [s]', 'fontsize', 14);
b = legend('TSF','EKF', 'Location','SouthEast');
subplot(313), plot(qualisys(1,:), bias2_est(3,:), '-g', qualisys(1,:), bias2_est2(3,:), 'b'), ylabel('Bias in a_z^b [m/s^2]', 'fontsize', 14), xlabel('Time [s]','fontsize', 14);
c = legend('TSF','EKF', 'Location','NorthEast');

set(a,'FontSize',14)
set(b,'FontSize',14)
set(c,'FontSize',14)

fg5.PaperPositionMode = 'auto';
print(fg5,filetype,strcat(folder,filename));




