classdef ltvk < handle 
     % LTV Kalman filter 
        %   Stage 2 of TSF
    
    properties
        h 
        
        A
        
        E
        
        B
      
        Q
         
        P_bar = diag([0.1^2 0.1^2 0.1^3 1e-1 1e-4 1e-4 1e-4 1e-5 1e-5 5*1e-6]); 
        
        h1 
        
        K = zeros(10,4); 
        
        x_bar
        
        x_est

        P_est
        
        acu
        
        gn = [0;0;9.81];

        std_range = 0.0001; %0.000104207; 
        
        var_acc_x = 1e-4; %1e-4;%7*1e-3; %1.6765331232158308e-04;%e-04; % 1e-3
        
        var_acc_y = 1e-4;%1e-2;%7*1e-3; %1.623284546288902e-04;%e-04; % 1e-3
        
        var_acc_z = 1e-3; %1e-1;%1e-2; %3.342784513438293e-04; %e-04; % 1e-3
        
        std_bias_x = 1e-6; %1e-5; %1e-3;%0.01; %1e-10; 
     
        std_bias_y = 1e-6;%1e-5; %1e-3; %0.01; 
        
        std_bias_z = 1e-6; %1e-3; %0.01; 
        
    end
    
    methods
        
         function update(ltv,r,input) 
             
             % Define LTV system 
                  
             ltv.A = [zeros(3,4) eye(3) zeros(3,3);
                      zeros(1,10);
                      zeros(3,7) -input.rot;
                      zeros(3,10)];  
 
             ltv.E = [zeros(3,7); 
                      1 zeros(1,6); 
                      zeros(3,1) -input.rot zeros(3,3); 
                      zeros(3,4) eye(3)];
                  
             ltv.B = [zeros(4,3) zeros(4,3); 
                      input.rot eye(3); 
                      zeros(3,3) zeros(3,3)];
                  
             % Find discrete matrices for A, E and B
            
            [phi, gamma] = c2d(ltv.A, ltv.E, ltv.h); 
            [~, delta] = c2d(ltv.A, ltv.B, ltv.h);
            
            % Define time-varying measurement matrix 
            
            C = [r.Cy zeros(4,6)]; 
            
             % Find process noise covariance matrix, Q
            
            ltv.Q = diag([1e-7 ltv.var_acc_x ltv.var_acc_y ltv.var_acc_z ltv.std_bias_x^2 ltv.std_bias_y^2 ltv.std_bias_z^2]);
            
            
            if input.range
                
                % Compute Kalman gain factor

                ltv.K = ltv.P_bar*C'*inv(C*ltv.P_bar*C' + r.R); 

                % Constructed measurement

                Z = r.z;
                D = -r.l; 
                Z_bar = C*ltv.x_bar + D*r.r1; 

                % Estimate update

                ltv.x_est = ltv.x_bar + ltv.K*(Z - Z_bar);
                ltv.P_est = (eye(10) - ltv.K*C)*ltv.P_bar*(eye(10)-ltv.K*C)' + ltv.K*r.R*ltv.K'; 
                
                input.range = 0;  
                
            else 
                ltv.K = zeros(10,4); 
                ltv.x_est = ltv.x_bar; 
                ltv.P_est = ltv.P_bar; 

                
            end
            
            % Estimate propagation 
            u = [input.acc'; ltv.gn]; 
            ltv.x_bar = phi*ltv.x_est + delta*u;  
            ltv.P_bar = phi*ltv.P_est*phi' + gamma*ltv.Q*gamma'; 
         
         end
         
    end
    
end

