% TRAJECTORY 

filetype = '-depsc2';
folder   = 'figures/';
filename ='s_trans_traj';

%-Plotting
fg1 = figure(1);
hold on
clf;

hold on;
load('transient.mat')

plot(pos_est(1,:), pos_est(2,:), 'g', pos_est2(1,:), pos_est2(2,:),'b', qualisys(:,2), qualisys(:,3), '-r');
xlabel('North [m]', 'fontsize', 14), ylabel('East [m]', 'fontsize', 14); 
L = legend('TSF','EKF','Qualisys','Location','NorthWest');

set(L, 'fontsize', 14); 

fg1.PaperPositionMode = 'auto';
print(fg1,filetype,strcat(folder,filename));

% POSITION ERROR 

filetype = '-depsc2';
folder   = 'figures/';
filename ='s_trans_pos_error1';

%-Plot 1 settings

%-Plotting
fg2 = figure(2);
hold on
clf;

subplot(311), plot(error1(1,:), error1(2,:), 'g',error2(1,:), error2(2,:), 'b'), ylabel('North [m]','fontsize', 14), xlabel('Time [s]', 'fontsize', 14);
a = legend('TSF','EKF','Location','NorthEast'); 
subplot(312), plot(error1(1,:), error1(3,:), 'g', error2(1,:), error2(3,:), 'b'), ylabel('East [m]', 'fontsize', 14), xlabel('Time [s]', 'fontsize', 14);
b = legend('TSF','EKF', 'Location','SouthEast');
subplot(313), plot(error1(1,:), error1(4,:), 'g', error2(1,:), error2(4,:), 'b'), ylabel('Down [m]', 'fontsize', 14), xlabel('Time [s]','fontsize', 14);
c = legend('TSF','EKF', 'Location','NorthEast');

set(a,'FontSize',14)
set(b,'FontSize',14)
set(c,'FontSize',14)

fg1.PaperPositionMode = 'auto';
print(fg2,filetype,strcat(folder,filename));

filetype = '-depsc2';
folder   = 'figures/';
filename ='s_trans_vel';

%-Plotting
fg3 = figure(3);
hold on
clf;

subplot(311), plot(error1(1,:), errorv1(1,:), '-g', error2(1,:), errorv2(1,:), 'b'), ylabel('North [m/s]','fontsize', 14), xlabel('Time [s]', 'fontsize', 14);
a = legend('TSF','EKF','Location','NorthEast'); 
subplot(312), plot(error1(1,:), errorv1(2,:), '-g', error2(1,:), errorv2(2,:), 'b'), ylabel('East [m/s]', 'fontsize', 14), xlabel('Time [s]', 'fontsize', 14);
b = legend('TSF','EKF', 'Location','SouthEast');
subplot(313), plot(error1(1,:), errorv1(3,:), '-g', error2(1,:), errorv2(3,:), 'b'), ylabel('Down [m/s]', 'fontsize', 14), xlabel('Time [s]','fontsize', 14);
c = legend('TSF','EKF', 'Location','NorthEast');

set(a,'FontSize',14)
set(b,'FontSize',14)
set(c,'FontSize',14)

fg3.PaperPositionMode = 'auto';
print(fg3,filetype,strcat(folder,filename));

filetype = '-depsc2';
folder   = 'figures/';
filename ='s_trans_wavebias';

%-Plotting
fg4 = figure(4);
hold on
clf;

plot(time(1,:), sqrt(bias_est)*1450, time(1,:), sqrt(bias_est2)*1450), xlabel('Time [s]', 'fontsize', 14), ylabel('Beta [-]', 'fontsize', 14);  
a = legend('TSF', 'EKF'); 
set(a,'FontSize',14)

fg4.PaperPositionMode = 'auto';
print(fg4,filetype,strcat(folder,filename));

filetype = '-depsc2';
folder   = 'figures/';
filename ='s_trans_vel_true';

%-Plotting
fg5 = figure(5);
hold on
clf;


subplot(311), plot(error1(1,:), vel_n(1,:), '-g'), ylabel('North [m/s]','fontsize', 14), xlabel('Time [s]', 'fontsize', 14);
a = legend('refvel','Location','NorthEast'); 
subplot(312), plot(error1(1,:), vel_n(2,:), '-g'), ylabel('East [m/s]', 'fontsize', 14), xlabel('Time [s]', 'fontsize', 14);
b = legend('refvel','Location','SouthEast');
subplot(313), plot(error1(1,:), vel_n(3,:), '-g'), ylabel('Down [m/s]', 'fontsize', 14), xlabel('Time [s]','fontsize', 14);
c = legend('refvel', 'Location','NorthEast');

set(a,'FontSize',14)
set(b,'FontSize',14)
set(c,'FontSize',14)

fg5.PaperPositionMode = 'auto';
print(fg5,filetype,strcat(folder,filename));


filetype = '-depsc2';
folder   = 'figures/';
filename ='s_trans_bias2';

%-Plotting
fg6 = figure(6);
hold on
clf;

subplot(311), plot(time(1,:), bias2_est(1,:), '-g',time(1,:), bias2_est2(1,:), '-b'), ylabel('Bias a_x^b [m/s^2]','fontsize', 14), xlabel('Time [s]', 'fontsize', 14);
a = legend('TSF','EKF','Location','NorthEast'); 
subplot(312), plot(time(1,:), bias2_est(2,:), '-g',time(1,:), bias2_est2(2,:), '-b'), ylabel('Bias a_y^b [m/s^2]', 'fontsize', 14), xlabel('Time [s]', 'fontsize', 14);
b = legend('TSF','EKF','Location','SouthEast');
subplot(313), plot(time(1,:), bias2_est(3,:), '-g',time(1,:), bias2_est2(3,:), '-b'), ylabel('Bias a_z^b [m/s^2]', 'fontsize', 14), xlabel('Time [s]','fontsize', 14);
c = legend('TSF', 'EKF', 'Location','NorthEast');

set(a,'FontSize',14)
set(b,'FontSize',14)
set(c,'FontSize',14)

fg6.PaperPositionMode = 'auto';
print(fg6,filetype,strcat(folder,filename));

% POSITION ERROR 

filetype = '-depsc2';
folder   = 'figures/';
filename ='s_trans_pos_error2';

%-Plot 1 settings

%-Plotting
fg7 = figure(7);
hold on
clf;

subplot(311), plot(error1(1,1:48), error1(2,1:48), 'g',error2(1,1:48), error2(2,1:48), 'b'), ylabel('North [m]','fontsize', 14), xlabel('Time [s]', 'fontsize', 14);
a = legend('TSF','EKF','Location','NorthEast'); 
subplot(312), plot(error1(1,1:48), error1(3,1:48), 'g', error2(1,1:48), error2(3,1:48), 'b'), ylabel('East [m]', 'fontsize', 14), xlabel('Time [s]', 'fontsize', 14);
b = legend('TSF','EKF', 'Location','SouthEast');
subplot(313), plot(error1(1,1:48), error1(4,1:48), 'g', error2(1,1:48), error2(4,1:48), 'b'), ylabel('Down [m]', 'fontsize', 14), xlabel('Time [s]','fontsize', 14);
c = legend('TSF','EKF', 'Location','NorthEast');

set(a,'FontSize',14)
set(b,'FontSize',14)
set(c,'FontSize',14)

fg7.PaperPositionMode = 'auto';
print(fg7,filetype,strcat(folder,filename));


filetype = '-depsc2';
folder   = 'figures/';
filename ='s_trans_wavebias2';

%-Plot 1 settings
xLabel_FSize = 14;
yLabel_FSize = 14;
legend_FSize = 14;

%-Plotting
fg8 = figure(8);
hold on
clf;

plot(time(1,1:995), sqrt(bias_est(1,1:995))*1450, time(1,1:995), sqrt(bias_est2(1,1:995))*1450), xlabel('Time [s]', 'fontsize', 14), ylabel('Beta [-]', 'fontsize', 14);  
a = legend('TSF', 'EKF'); 
set(a,'FontSize',14)

fg8.PaperPositionMode = 'auto';
print(fg8,filetype,strcat(folder,filename));

filetype = '-depsc2';
folder   = 'figures/';
filename ='s_trans_bias22';

%-Plotting
fg9 = figure(9);
hold on
clf;

subplot(311), plot(time(1,1:995), bias2_est(1,1:995), '-g',time(1,1:995), bias2_est2(1,1:995), '-b'), ylabel('Bias a_x^ [m/s^2]','fontsize', 14), xlabel('Time [s]', 'fontsize', 14);
a = legend('TSF','EKF','Location','NorthEast'); 
subplot(312), plot(time(1,1:995), bias2_est(2,1:995), '-g',time(1,1:995), bias2_est2(2,1:995), '-b'), ylabel('Bias a_y^b [m/s^2]', 'fontsize', 14), xlabel('Time [s]', 'fontsize', 14);
b = legend('TSF','EKF','Location','SouthEast');
subplot(313), plot(time(1,1:995), bias2_est(3,1:995), '-g',time(1,1:995), bias2_est2(3,1:995), '-b'), ylabel('Bias a_z^b [m/s^2]', 'fontsize', 14), xlabel('Time [s]','fontsize', 14);
c = legend('TSF', 'EKF', 'Location','NorthEast');

set(a,'FontSize',14)
set(b,'FontSize',14)
set(c,'FontSize',14)

fg9.PaperPositionMode = 'auto';
print(fg9,filetype,strcat(folder,filename));


filetype = '-depsc2';
folder   = 'figures/';
filename ='s_trans_bias3';

%-Plotting
fg10 = figure(10);
hold on
clf;

subplot(311), plot(time(1,:), pos_est(1,:), '-g',time(1,:), pos_est2(1,:), '-b'), ylabel('Bias a_x^b [m/s^2]','fontsize', 14), xlabel('Time [s]', 'fontsize', 14);
d = legend('TSF','EKF','Location','NorthEast'); 
subplot(312), plot(time(1,:), pos_est(2,:), '-g',time(1,:), pos_est2(2,:), '-b'), ylabel('Bias a_y^b [m/s^2]', 'fontsize', 14), xlabel('Time [s]', 'fontsize', 14);
e = legend('TSF','EKF','Location','SouthEast');
subplot(313), plot(time(1,:), pos_est(3,:), '-g',time(1,:), pos_est2(3,:), '-b'), ylabel('Bias a_x^b [m/s^2]', 'fontsize', 14), xlabel('Time [s]','fontsize', 14);
f = legend('TSF', 'EKF', 'Location','NorthEast');

set(d,'FontSize',14)
set(e,'FontSize',14)
set(f,'FontSize',14)

fg10.PaperPositionMode = 'auto'; % [20 20 20];%'auto';
print(fg10,filetype,strcat(folder,filename));

filetype = '-depsc2';
folder   = 'figures/';
filename ='s_trans_joker';

%-Plot 1 settings

%-Plotting
fg11 = figure(11);
hold on
clf;

subplot(311), plot(time(1,:), bias2_est(1,:), 'g', time(1,:), bias2_est2(1,:),'b', 'LineWidth',1), ylabel('Bias a_x^b [m/s^2]','fontsize', 14), xlabel('Time [s]', 'fontsize', 14);
a = legend('TSF','EKF','Location','NorthEast'); 
subplot(312), plot(time(1,:), bias2_est(2,:), 'g', time(1,:), bias2_est2(2,:), 'b', 'LineWidth',1), ylabel('Bias a_y^b [m/s^2]', 'fontsize', 14), xlabel('Time [s]', 'fontsize', 14);
b = legend('TSF','EKF', 'Location','SouthEast');
subplot(313), plot(time(1,:), bias2_est(3,:), 'g', time(1,:), bias2_est2(3,:), 'b', 'LineWidth',1), ylabel('Bias a_z^b [m/s^2]', 'fontsize', 14), xlabel('Time [s]','fontsize', 14);
c = legend('TSF','EKF', 'Location','NorthEast');

set(a,'FontSize',16)
set(b,'FontSize',16)
set(c,'FontSize',16)

fg11.PaperPositionMode = 'auto';
print(fg11,filetype,strcat(folder,filename));

filetype = '-depsc2';
folder   = 'figures/';
filename ='s_steady_angles';

%-Plotting
fg12 = figure(12);
hold on
clf;

subplot(311), plot(qualisys(:,1), qualisys(:,5)), xlabel('Time [s]', 'fontsize', 14), ylabel('Roll [rad]', 'fontsize', 14), a = legend('\phi'); 
subplot(312), plot(qualisys(:,1), qualisys(:,6)), xlabel('Time [s]', 'fontsize', 14), ylabel('Pitch [rad]', 'fontsize', 14), b = legend('\theta'); 
subplot(313), plot(qualisys(:,1), qualisys(:,7)), xlabel('Time [s]', 'fontsize', 14), ylabel('Yaw [rad]', 'fontsize', 14), c = legend('\psi'); 

set(a,'FontSize',14)
set(b,'FontSize',14)
set(c,'FontSize',14)

fg12.PaperPositionMode = 'auto';
print(fg12,filetype,strcat(folder,filename));

filetype = '-depsc2';
folder   = 'figures/';
filename ='s_trans_vel2';

%-Plotting
fg13 = figure(13);
hold on
clf;

subplot(311), plot(error1(1,1:48), errorv1(1,1:48), '-g', error2(1,1:48), errorv2(1,1:48), 'b'), ylabel('North [m/s]','fontsize', 14), xlabel('Time [s]', 'fontsize', 14);
a = legend('TSF','EKF','Location','NorthEast'); 
subplot(312), plot(error1(1,1:48), errorv1(2,1:48), '-g', error2(1,1:48), errorv2(2,1:48), 'b'), ylabel('East [m/s]', 'fontsize', 14), xlabel('Time [s]', 'fontsize', 14);
b = legend('TSF','EKF', 'Location','SouthEast');
subplot(313), plot(error1(1,1:48), errorv1(3,1:48), '-g', error2(1,1:48), errorv2(3,1:48), 'b'), ylabel('Down [m/s]', 'fontsize', 14), xlabel('Time [s]','fontsize', 14);
c = legend('TSF','EKF', 'Location','NorthEast');

set(a,'FontSize',14)
set(b,'FontSize',14)
set(c,'FontSize',14)

fg13.PaperPositionMode = 'auto';
print(fg13,filetype,strcat(folder,filename));
