function [ ] = generate_plots(t_end, h, trans, pos_n,vel_n, pos_est,vel_est,...
    bias_est, pos_est2, vel_est2, bias_est2, stage1, stage1_2, stage2, stage3,...
    bias2_est, bias_20, bias2_est2) 


%UNTITLED4 Summary of this function goes here
%   Detailed explanation goes here


figure()
plot(pos_n(2,1:end-1), pos_n(1,1:end-1), 'b');
hold on
plot(pos_est(2,1:end-1), pos_est(1,1:end-1), 'r'); 
legend('True position in NED', 'Estimated position in NED');
xlabel('East [m]');
ylabel('North [m]');
title('ROV trace');

figure()
plot3(pos_n(1,:), pos_n(2,:), pos_n(3,:)); 
axis([-20 80 -20 60 -20 40]); 
xlabel('North [m]');
ylabel('East [m]');
zlabel('Up [m]');
title('Plot of trajectory')
% 
figure()
subplot(311), plot(h:h:t_end, vel_n(1,:), 'b', h:h:t_end-h, vel_est(1,1:end-1),'g'), xlabel('Time [s]'), ylabel('North velocity [m/s]'), legend('True', 'EKF', 'location','northeast'), title('North velocity');
subplot(312), plot(h:h:t_end, vel_n(2,:), 'b', h:h:t_end-h, vel_est(2,1:end-1),'g'), xlabel('Time [s]'), ylabel('East velocity [m/s]'), legend('True', 'EKF', 'location','northeast'), title('East velocity');
subplot(313), plot(h:h:t_end, vel_n(3,:), 'b', h:h:t_end-h, vel_est(3,1:end-1),'g'), xlabel('Time [s]'), ylabel('Down velocity [m/s]'), legend('True', 'EKF', 'location','northeast'), title('Down velocity');
% 
% figure()
% plot3(pos_n(1,:), pos_n(2,:), pos_n(3,:),'b', pos_gen(1,1:end-1), pos_gen(2,1:end-1), pos_gen(3,1:end-1), '*r'); 
% axis([-20 80 -20 60 -20 40]); 
% legend('True trajectory', 'Algebraic transformation');
% xlabel('North [m]');
% ylabel('East [m]');
% zlabel('Up [m]');

% figure()
% plot(h:h:t_end-h, pos_n(3,1:end-1), 'b', h:h:t_end-h, pos_gen(3,1:end-1), '*r'); 
% %axis([-20 80 -20 60 -20 40]); 
% legend('True trajectory', 'Algebraic transformation');
% xlabel('North [m]');
% ylabel('East [m]');

% figure()
% plot(h:h:t_end-h, pos_n(3,1:end-1), 'b'); 
% %axis([-20 80 -20 60 -20 40]); 
% legend('True trajectory');
% xlabel('North [m]');
% ylabel('East [m]');

% figure()
% plot(pos_n(2,:), pos_n(1,:), 'b', pos_gen(2,1:end-1), pos_gen(1,1:end-1), '*r'); 
% axis([-5 35 0 70]); 
% legend('True trajectory', 'Algebraic transformation');
% xlabel('North [m]');
% ylabel('East [m]');


figure()
subplot(311), plot(h:h:t_end, pos_n(1,:), 'b', h:h:t_end-h, pos_est(1,1:end-1), 'g'), title('Position in North'), xlabel('Time [s]'), ylabel('North [m]'), legend('True', 'EKF', 'location', 'northwest');
subplot(312), plot(h:h:t_end, pos_n(2,:), 'b', h:h:t_end-h, pos_est(2,1:end-1), 'g'), title('Position in East'), xlabel('Time [s]'), ylabel('East [m]'), legend('True', 'EKF', 'location', 'northwest');
subplot(313), plot(h:h:t_end, pos_n(3,:), 'b', h:h:t_end-h, pos_est(3,1:end-1), 'g'), title('Position in Down'), xlabel('Time [s]'), ylabel('Down [m]'),legend('True', 'EKF', 'location', 'northwest');

figure()
subplot(411), plot(h:h:t_end-h, stage1(1,1:end-1), 'b', h:h:t_end-h, stage1_2(1,1:end-1), 'r'), title('Position in North'), xlabel('Time [s]'), ylabel('North [m]'), legend('Stage 1-selected', 'Stage 1 - not selected','location', 'northwest');
subplot(412), plot(h:h:t_end-h, stage1(2,1:end-1), 'b', h:h:t_end-h, stage1_2(2,1:end-1), 'r'), title('Position in East'), xlabel('Time [s]'), ylabel('East [m]'), legend('Stage 1-selected', 'Stage 1 - not selected','location', 'northwest');
subplot(413), plot(h:h:t_end-h, stage1(3,1:end-1), 'b', h:h:t_end-h, stage1_2(3,1:end-1), 'r'), title('Position in Down'), xlabel('Time [s]'), ylabel('Down [m]'), legend('Stage 1-selected', 'Stage 1 - not selected','location', 'northwest');
subplot(414), plot(h:h:t_end-h, stage1(4,1:end-1), 'b', h:h:t_end-h, stage1_2(4,1:end-1), 'r'), title('Estimated bias'), xlabel('Time [s]'), ylabel('\beta [m]'), legend('Stage 1-selected', 'Stage 1 - not selected','location', 'northwest');

figure()
subplot(311), plot(h:h:t_end-h, pos_n(1,1:end-1)-stage1(1,1:end-1), 'g', h:h:t_end-h, pos_n(1,1:end-1)-stage2(1,1:end-1), 'r', h:h:t_end-h, pos_n(1,1:end-1)-stage3(1,1:end-1),'b'), title('Position error in North'), xlabel('Time [s]'), ylabel('North [m]'), legend('Stage 1', 'Stage 2', 'Stage 3','location', 'northwest');
subplot(312), plot(h:h:t_end-h, pos_n(2,1:end-1)-stage1(2,1:end-1), 'g', h:h:t_end-h, pos_n(2,1:end-1)-stage2(2,1:end-1), 'r', h:h:t_end-h, pos_n(2,1:end-1)-stage3(2,1:end-1),'b'), title('Position error in East'), xlabel('Time [s]'), ylabel('East [m]'), legend('Stage 1', 'Stage 2', 'Stage 3','location', 'northwest');
subplot(313), plot(h:h:t_end-h, pos_n(3,1:end-1)-stage1(3,1:end-1), 'g', h:h:t_end-h, pos_n(3,1:end-1)-stage2(3,1:end-1), 'r', h:h:t_end-h, pos_n(3,1:end-1)-stage3(3,1:end-1),'b'), title('Position error in Down'), xlabel('Time [s]'), ylabel('Down [m]'), legend('Stage 1', 'Stage 2', 'Stage 3','location', 'northwest');

bias = sqrt(bias_est(1,1:end-1))*1450; 
n = length(bias_est(1,1:end-1)); 
bias_true = 1450*ones(1,n); 
rms = sqrt((bias_est(1,1:end-1)-1).^2/n); 
%rms = sqrt(mean((1-bias_est(1,1:end-1)).^2)); 
bias2 = sqrt(bias_est2(1,1:end-1))*1450; 

% bias_true2 = 1450*ones(1,n); 
% rms2 = sqrt((bias_est2(1,1:end-1)-1).^2/n);

figure()
subplot(211), plot(h:h:t_end-h, bias_true, h:h:t_end-h, bias), title('Wave speed estimate'), xlabel('Time [s]'), ylabel('Beta [-]'), legend('True', 'TSF'); 
subplot(212), plot(h:h:t_end-h, rms), title('RMSE for Beta for TSF'), xlabel('Time [s]'), ylabel('RMSE'); 

figure()
subplot(211), plot(h:h:t_end-h, bias_true, h:h:t_end-h, bias, h:h:t_end-h, bias2), title('Wave speed estimate'), xlabel('Time [s]'), ylabel('Beta [-]'), legend('True', 'TSF', 'EKF'); 
subplot(212), plot(h:h:t_end-h, rms), title('RMSE for Beta for TSF'), xlabel('Time [s]'), ylabel('RMSE'); 

errorx = pos_n(1,1:end-1) - pos_est(1,1:end-1);
errory = pos_n(2,1:end-1) - pos_est(2,1:end-1); 
errorz = pos_n(3,1:end-1) - pos_est(3,1:end-1); 

errorvx = vel_n(1,1:end-1) - vel_est(1,1:end-1);
errorvy = vel_n(2,1:end-1) - vel_est(2,1:end-1);
errorvz = vel_n(3,1:end-1) - vel_est(3,1:end-1); 

figure()
subplot(311), plot(h:h:t_end-h, errorx, 'Linewidth', 1), title('North position error TSF'), xlabel('Time [s]'), ylabel('North position error [m]'); 
subplot(312), plot(h:h:t_end-h, errory, 'Linewidth', 1), title('East position error TSF'), xlabel('Time [s]'), ylabel('East position error [m]'); 
subplot(313), plot(h:h:t_end-h, errorz, 'Linewidth', 1), title('Down position error TSF'), xlabel('Time [s]'), ylabel('Down position error [m]'); 

figure()
subplot(311), plot(h:h:t_end-h, errorvx, 'Linewidth', 1), title('North Velocity error TSF'), xlabel('Time [s]'), ylabel('North Velocity error [m/s]'); 
subplot(312), plot(h:h:t_end-h, errorvy, 'Linewidth', 1), title('East Velocity error TSF'), xlabel('Time [s]'), ylabel('East Velocity error [m/s]'); 
subplot(313), plot(h:h:t_end-h, errorvz, 'Linewidth', 1), title('Down Velocity error TSF'), xlabel('Time [s]'), ylabel('Down Velocity error [m/s]'); 

errorx2 = pos_n(1,1:end-1) - pos_est2(1,1:end-1);
errory2 = pos_n(2,1:end-1) - pos_est2(2,1:end-1); 
errorz2 = pos_n(3,1:end-1) - pos_est2(3,1:end-1); 

errorvx2 = vel_n(1,1:end-1) - vel_est2(1,1:end-1);
errorvy2 = vel_n(2,1:end-1) - vel_est2(2,1:end-1);
errorvz2 = vel_n(3,1:end-1) - vel_est2(3,1:end-1); 

% figure()
% subplot(311), plot(h:h:t_end-h, errorx2, 'Linewidth', 1), title('North position error EKF'), xlabel('Time [s]'), ylabel('North position error [m]'); 
% subplot(312), plot(h:h:t_end-h, errory2, 'Linewidth', 1), title('East position error EKF'), xlabel('Time [s]'), ylabel('East position error [m]'); 
% subplot(313), plot(h:h:t_end-h, errorz2, 'Linewidth', 1), title('Down position error EKF'), xlabel('Time [s]'), ylabel('Down position error [m]'); 
% 
% figure()
% subplot(311), plot(h:h:t_end-h, errorvx2, 'Linewidth', 1), title('North Velocity error EKF '), xlabel('Time [s]'), ylabel('North Velocity error [m/s]'); 
% subplot(312), plot(h:h:t_end-h, errorvy2, 'Linewidth', 1), title('East Velocity error EKF'), xlabel('Time [s]'), ylabel('East Velocity error [m/s]'); 
% subplot(313), plot(h:h:t_end-h, errorvz2, 'Linewidth', 1), title('Down Velocity error EKF'), xlabel('Time [s]'), ylabel('Down Velocity error [m/s]'); 

figure()
subplot(311), plot(h:h:t_end-h, errorx, 'g', h:h:t_end-h, errorx2, 'b'), title('North position error'), xlabel('Time [s]'), ylabel('North position error [m]'), legend('TSF', 'EKF'); 
subplot(312), plot(h:h:t_end-h, errory, 'g', h:h:t_end-h, errory2, 'b'), title('East position error'), xlabel('Time [s]'), ylabel('East position error [m]'), legend('TSF', 'EKF'); 
subplot(313), plot(h:h:t_end-h, errorz, 'g', h:h:t_end-h, errorz2, 'b'), title('Down position error'), xlabel('Time [s]'), ylabel('Down position error [m]'), legend('TSF', 'EKF');

figure()
subplot(311), plot(h:h:t_end-h, errorvx, 'g', h:h:t_end-h, errorvx2, 'b'), title('North Velocity error'), xlabel('Time [s]'), ylabel('North Velocity error [m/s]'), legend('TSF', 'EKF'); 
subplot(312), plot(h:h:t_end-h, errorvy, 'g', h:h:t_end-h, errorvy2, 'b'), title('East Velocity error'), xlabel('Time [s]'), ylabel('East Velocity error [m/s]'), legend('TSF', 'EKF');  
subplot(313), plot(h:h:t_end-h, errorvz, 'g', h:h:t_end-h, errorvz2, 'b'), title('Down Velocity error'), xlabel('Time [s]'), ylabel('Down Velocity error [m/s]'), legend('TSF', 'EKF'); 


figure()
plot3(pos_n(1,1:end-1) , pos_n(2,1:end-1), pos_n(3,1:end-1), 'b', pos_est(1,1:end-1), pos_est(2,1:end-1), pos_est(3,1:end-1), 'g', pos_est2(1,1:end-1), pos_est2(2,1:end-1), pos_est2(3,1:end-1), 'r' ); 
%axis([-20 80 -10 40 -10 40]); 
%axis([-30 100 -13 50 -10 40]); 
axis([-10 70 -20 70 -40 40]);
hold on;
plot3(trans.p1(1), trans.p1(2), trans.p1(3), 'ko'); 
plot3(trans.p2(1), trans.p2(2), trans.p2(3), 'ko'); 
plot3(trans.p3(1), trans.p3(2), trans.p3(3), 'ko'); 
plot3(trans.p4(1), trans.p4(2), trans.p4(3), 'ko'); 
legend('True trajectory', 'TSF', 'EKF', 'Transponders'); 
xlabel('North [m]');
ylabel('East [m]');
zlabel('Up [m]');


bias2_true = [bias_20(1)*ones(1,length(h:h:t_end-h)); 
              bias_20(2)*ones(1,length(h:h:t_end-h)); 
              bias_20(3)*ones(1,length(h:h:t_end-h))]; 
figure()
subplot(311), plot(h:h:t_end-h, bias2_est(1,1:end-1), h:h:t_end-h, bias2_est2(1,1:end-1), h:h:t_end-h, bias2_true(1,:), 'Linewidth', 1), legend('TSF', 'EKF', 'True'), title('Bias in a_x^b'), xlabel('Time [s]'), ylabel('Bias [m^2]'); 
subplot(312), plot(h:h:t_end-h, bias2_est(2,1:end-1), h:h:t_end-h, bias2_est2(2,1:end-1), h:h:t_end-h, bias2_true(2,:), 'Linewidth', 1), legend('TSF', 'EKF', 'True'), title('Bias in a_y^b'), xlabel('Time [s]'), ylabel('Bias [m^2]'); 
subplot(313), plot(h:h:t_end-h, bias2_est(3,1:end-1), h:h:t_end-h, bias2_est2(3,1:end-1), h:h:t_end-h, bias2_true(3,:), 'Linewidth', 1), legend('TSF', 'EKF', 'True'), title('Bias in a_z^b'), xlabel('Time [s]'), ylabel('Bias [m^2]'); 


end


