% TRAJECTORY 

filetype = '-depsc2';
%filetype='-depsc3';
folder   = 'figures/';
filename ='tsf_trans_pos';

%-Plotting
fg5 = figure(1);
hold on
clf;

hold on;
load('transient.mat')

errorx = pos_n(1,1:end-1) - pos_est(1,1:end-1);
errory = pos_n(2,1:end-1) - pos_est(2,1:end-1); 
errorz = pos_n(3,1:end-1) - pos_est(3,1:end-1); 

errorx2 = pos_n(1,1:end-1) - pos_est2(1,1:end-1);
errory2 = pos_n(2,1:end-1) - pos_est2(2,1:end-1); 
errorz2 = pos_n(3,1:end-1) - pos_est2(3,1:end-1);

subplot(311), plot(h:h:t_end-h, errorx, '-g', h:h:t_end-h, errorx2, 'b'), ylabel('North [m]','fontsize', 14), xlabel('Time [s]', 'fontsize', 14);
a = legend('TSF','EKF','Location','NorthEast'); 
subplot(312), plot(h:h:t_end-h, errory, '-g', h:h:t_end-h, errory2, 'b'), ylabel('East [m]', 'fontsize', 14), xlabel('Time [s]', 'fontsize', 14);
b = legend('TSF','EKF', 'Location','SouthEast');
subplot(313), plot(h:h:t_end-h, errorz, '-g', h:h:t_end-h, errorz2, 'b'), ylabel('Down [m]', 'fontsize', 14), xlabel('Time [s]','fontsize', 14);
c = legend('TSF','EKF', 'Location','NorthEast');

set(a, 'fontsize', 14); 
set(b, 'fontsize', 14); 
set(c, 'fontsize', 14); 

fg5.PaperPositionMode = 'auto';
print(fg5,filetype,strcat(folder,filename));

% POSITION ERROR 

filetype = '-depsc2';
folder   = 'figures/';
filename ='tsf_trans_vel';

%-Plotting
fg2 = figure(2);
hold on
clf;

errorvx = vel_n(1,1:end-1) - vel_est(1,1:end-1);
errorvy = vel_n(2,1:end-1) - vel_est(2,1:end-1);
errorvz = vel_n(3,1:end-1) - vel_est(3,1:end-1); 

errorvx2 = vel_n(1,1:end-1) - vel_est2(1,1:end-1);
errorvy2 = vel_n(2,1:end-1) - vel_est2(2,1:end-1);
errorvz2 = vel_n(3,1:end-1) - vel_est2(3,1:end-1); 

subplot(311), plot(h:h:t_end-h, errorvx, '-g', h:h:t_end-h, errorvx2, 'b'), ylabel('North [m/s]','fontsize', 14), xlabel('Time [s]', 'fontsize', 14);
a = legend('TSF','EKF','Location','NorthEast'); 
subplot(312), plot(h:h:t_end-h, errorvy, '-g', h:h:t_end-h, errorvy2, 'b'), ylabel('East [m/s]', 'fontsize', 14), xlabel('Time [s]', 'fontsize', 14);
b = legend('TSF','EKF', 'Location','SouthEast');
subplot(313), plot(h:h:t_end-h, errorvz, '-g', h:h:t_end-h, errorvz2, 'b'), ylabel('Down [m/s]', 'fontsize', 14), xlabel('Time [s]','fontsize', 14);
c = legend('TSF','EKF', 'Location','NorthEast');

set(a,'FontSize',14)
set(b,'FontSize',14)
set(c,'FontSize',14)

fg2.PaperPositionMode = 'auto';
print(fg2,filetype,strcat(folder,filename));


filetype = '-depsc2';
folder   = 'figures/';
filename ='tsf_trans_bias';


%-Plotting
fg3 = figure(3);
hold on
clf;

bias = sqrt(bias_est(1,1:end-1))*1450;  
n = length(bias_est(1,1:end-1)); 
bias_true = 1450*ones(1,n); 
rms1 = sqrt((bias_est(1,1:end-1)-1).^2/n); 
rms2 = sqrt((bias_est2(1,1:end-1)-1).^2/n); 
bias2 = sqrt(bias_est2(1,1:end-1))*1450; 

plot(h:h:t_end-h, bias_true, h:h:t_end-h, bias,h:h:t_end-h, bias2), xlabel('Time [s]', 'fontsize',14), ylabel('Beta [-]', 'fontsize',14);
a = legend('True', 'TSF', 'EKF'); 

set(a,'FontSize',14)

fg3.PaperPositionMode = 'auto';
print(fg3,filetype,strcat(folder,filename));

filetype = '-depsc2';
folder   = 'figures/';
filename ='tsf_trans_bias2';

%-Plotting
fg4 = figure(4);
hold on
clf;


bias2_true = [bias_20(1)*ones(1,length(h:h:t_end-h)); 
              bias_20(2)*ones(1,length(h:h:t_end-h)); 
              bias_20(3)*ones(1,length(h:h:t_end-h))]; 

subplot(311), plot(h:h:t_end-h, bias2_est(1,1:end-1), h:h:t_end-h, bias2_est2(1,1:end-1), h:h:t_end-h, bias2_true(1,:), 'Linewidth', 1), xlabel('Time [s]', 'fontsize', 14), ylabel('Bias in a_x^b [m/s^2]','fontsize', 14); 
a = legend('TSF', 'EKF', 'True');
subplot(312), plot(h:h:t_end-h, bias2_est(2,1:end-1), h:h:t_end-h, bias2_est2(2,1:end-1), h:h:t_end-h, bias2_true(2,:), 'Linewidth', 1), xlabel('Time [s]', 'fontsize',14), ylabel('Bias in a_y^b [m/s^2]','fontsize',14); 
b = legend('TSF', 'EKF', 'True'); 
subplot(313), plot(h:h:t_end-h, bias2_est(3,1:end-1), h:h:t_end-h, bias2_est2(3,1:end-1), h:h:t_end-h, bias2_true(3,:), 'Linewidth', 1), xlabel('Time [s]', 'fontsize', 14), ylabel('Bias in a_z^b [m/s^2]', 'fontsize', 14); 
c = legend('TSF', 'EKF', 'True'); 

set(a,'FontSize',14)
set(b,'FontSize',14)
set(c,'FontSize',14)

fg4.PaperPositionMode = 'auto';
print(fg4,filetype,strcat(folder,filename));


figure()
plot3(pos_n(1,1:end-1) , pos_n(2,1:end-1), pos_n(3,1:end-1), 'b', pos_est(1,1:end-1), pos_est(2,1:end-1), pos_est(3,1:end-1), 'g', pos_est2(1,1:end-1), pos_est2(2,1:end-1), pos_est2(3,1:end-1), 'r' ); 
axis([-10 70 -20 70 -40 40]);
hold on;
plot3(trans.p1(1), trans.p1(2), trans.p1(3), 'ko'); 
plot3(trans.p2(1), trans.p2(2), trans.p2(3), 'ko'); 
plot3(trans.p3(1), trans.p3(2), trans.p3(3), 'ko'); 
plot3(trans.p4(1), trans.p4(2), trans.p4(3), 'ko'); 
L = legend('True trajectory', 'TSF', 'EKF', 'Transponders'); 
set(L,'fontsize',14);
xlabel('North [m]', 'fontsize',14);
ylabel('East [m]',  'fontsize',14);
zlabel('Up [m]', 'fontsize',14);






