classdef simulator < handle
    %UNTITLED4 Summary of this class goes here
    %   Detailed explanation goes here
    
    properties % this are all the parameters that i need acces to when defining a class in my other script 
        posn
        q
        h
        velb
        acc_n
        acc_b
        std_acc = 0.01; 
        std_bias = 0.01
        b
        veln
        Rnb
    end
    
    methods
        function identify(sim, new)
             sim.h = sim.h + new; 
             disp(['This is the new time ', num2str(sim.h)]); 
        end
        
        function update(sim, input)
            
            [~, sim.Rnb, T] = quatern(sim.q); % Computes the quaternion linear and angular velocity transformation matrix
            sim.veln = sim.Rnb*(sim.velb + input.vel);   % Finding translational velocities in NED from velocities in BODY 
            %sim.acc_n = Smtrx(input.w)*Rnb*sim.velb+Rnb*input.dvel; %Can be used as acceleration measurements. Add noise by adding std_acc*randn(1)
            %sim.acc_n = Smtrx(input.w)*sim.Rnb*sim.velb + sim.Rnb*input.dvel + randn(3,1)*sim.std_acc - sim.b;%sim.noise;
            sim.acc_n = Smtrx(input.w)*sim.Rnb*sim.velb + sim.Rnb*input.dvel - [0;0;9.81]; 
            sim.acc_b = sim.Rnb'*sim.acc_n + randn(3,1)*sim.std_acc + sim.b; 
            
            % Integrate in order to get values of the trajectory at the next point
            % in time using Euler integration 
            
            sim.posn = sim.posn + sim.h*sim.veln; 
            sim.velb = sim.velb + sim.h*input.dvel;
            sim.q    = sim.q + sim.h*T*input.w;

            % Unit quaternion normalization 

            sim.q = sim.q/norm(sim.q); 

        end

        
        
    end
    
end

